// File: Bowling.java
// Score a game of bowling.
// Score is like at bowling alley
// Separation of Concerns: Data input and processing are independent
// Bonus for a strike is total of two next shots
// Bonus for a spare is next shot

import java.io.* ;
import java.awt.*;
import java.awt.event.*;


class BowlingFrame extends Frame
	implements ActionListener, WindowListener //, ItemListener
{private BowlFramePanel[] frame;
 private BowlFrame10Panel Ten;
 private Label InputPrompt,Shot1Prompt,Shot2Prompt;
 private Button Again,Quit;
 private int pins,shotBeingRead,shot1,shot2,frameNum=0,
			 nextFrameToScore=0,total=0;

 BowlingFrame()
 {super("Bowling!      Your Scoresheet...");
  setSize(800,160);
  this.setBackground(Color.white);
  this.setForeground(Color.blue);
  setLayout(null);
  addWindowListener(this);
  frame=new BowlFramePanel[9];
  for (int i=0;i<9;i++) {
	  frame[i]=new BowlFramePanel();
	  frame[i].setBounds(i*70+15,45,59,50);
	  // frame[i].setBounds(i*70+15,45,59,40);
	  add(frame[i]);
	  frame[i].setVisible(true);
  }
  Ten=new BowlFrame10Panel();
  Ten.setBounds(645,45,79,40);
  Ten.setVisible(true);
  add(Ten);
  Again=new Button("Again?");
  Again.setBounds(40,100,75,25);
  Again.addActionListener(this);
  add(Again);
  Again.setVisible(false);
  Quit=new Button("Quit?");
  Quit.setBounds(40,128,75,25);
  Quit.addActionListener(this);
  add(Quit);
  Quit.setVisible(false);
  setVisible(true);
  startActionListener(frameNum,1);
 }

 void startActionListener(int frameNum,int shotNum)
 {frame[frameNum].Shot[shotNum-1].addActionListener(this);
  frame[frameNum].Shot[shotNum-1].setEnabled(true);
  frame[frameNum].Shot[shotNum-1].setEditable(true);
  frame[frameNum].Shot[shotNum-1].requestFocus();
  shotBeingRead=shotNum;
 }

void stopActionListener(int frameNum,int shotNum)
 {frame[frameNum].Shot[shotNum-1].removeActionListener(this);
  frame[frameNum].Shot[shotNum-1].setEnabled(false);
  frame[frameNum].Shot[shotNum-1].setEditable(false);
//frame[frameNum].TextFieldToLabel(shotNum);
 }

//  shotBeingRead=((shotNum)%2)+1;


 public void actionPerformed(ActionEvent event)
 {if (frameNum<9) {
   if (shotBeingRead==1 &&
			frame[frameNum].Shot[0].getText().equals("10")) {
	   frame[frameNum].Shot[0].setText("X");
	   stopActionListener(frameNum++,1);
	   if (frameNum<9) {
		   startActionListener(frameNum,1);
	   }
	   else {
		   Ten.Shot[0].addActionListener(this);
		   Ten.Shot[0].setEnabled(true);
		   Ten.Shot[0].setEditable(true);
                   Ten.Shot[0].requestFocus();
	   }
   }
   else if (shotBeingRead==1) {
	   stopActionListener(frameNum,1);
	   shotBeingRead=2;
	   startActionListener(frameNum,2);
   }
   else {
	   if (frame[frameNum].getPins()==10)
		   frame[frameNum].Shot[1].setText("/");
   	   stopActionListener(frameNum++,2);
	   if (frameNum<9)
		   startActionListener(frameNum,1);
	   else {
		   Ten.Shot[0].addActionListener(this);
		   Ten.Shot[0].setEnabled(true);
		   Ten.Shot[0].setEditable(true);
                   Ten.Shot[0].requestFocus();
	   }
	   shotBeingRead=1;
   }
   // Update scores
   if (shotBeingRead==1) { // See if last three frames can be scored
	   if (nextFrameToScore==frameNum-3){
			total+=20+frame[frameNum-1].getShot(1);
			frame[frameNum-3].RunningTotal.setText("   "+String.valueOf(total));
			nextFrameToScore++;
	   }
	   if (nextFrameToScore==frameNum-2 && !frame[frameNum-1].isStrike()) {
		   if (frame[frameNum-2].isStrike())
				total+=10+frame[frameNum-1].getPins();
		   else if (frame[frameNum-2].isSpare())
				total+=10+frame[frameNum-1].getShot(1);
		   frame[frameNum-2].RunningTotal.setText("   "+String.valueOf(total));
  		   nextFrameToScore++;
	   }
	   else if (nextFrameToScore==frameNum-2 && frame[frameNum-2].isSpare()) {
		   total+=20;
		   frame[frameNum-2].RunningTotal.setText("   "+String.valueOf(total));
  		   nextFrameToScore++;
	   }
	   if (nextFrameToScore==frameNum-1 && frame[frameNum-1].getPins()!=10) {
		    total+=frame[frameNum-1].getPins();
			frame[frameNum-1].RunningTotal.setText("   "+String.valueOf(total));
			nextFrameToScore++;
	   }
   } // scoring if
  } // if frameNum < 9
  else if (frameNum==9 && shotBeingRead!=0) { // 10th frame
	  if (shotBeingRead==1) {
		Ten.Shot[0].removeActionListener(this);
  	        Ten.Shot[0].setEnabled(false);
		Ten.Shot[0].setEditable(false);
		if (Ten.Shot[0].getText().equals("10"))
			Ten.Shot[0].setText("X");
		shotBeingRead=2;
	        Ten.Shot[1].addActionListener(this);
		Ten.Shot[1].setEnabled(true);
		Ten.Shot[1].setEditable(true);
                Ten.Shot[1].requestFocus();
	  }
	  else if (shotBeingRead==2) {
		Ten.Shot[1].removeActionListener(this);
                Ten.Shot[1].setEnabled(false);
		Ten.Shot[1].setEditable(false);
		if (Ten.Shot[1].getText().equals("10"))
			Ten.Shot[1].setText("X");
		else if (Ten.isSpare())
			Ten.Shot[1].setText("/");
		if (Ten.getShot(1)==10 || Ten.isSpare()) {
		    Ten.Shot[2].addActionListener(this);
			Ten.Shot[2].setEnabled(true);
			Ten.Shot[2].setEditable(true);
			Ten.Shot[2].setVisible(true);
                        Ten.Shot[2].requestFocus();
			shotBeingRead=3;
		}
		else {
			Ten.Shot[2].setVisible(false);
			shotBeingRead=0;
		}
	  }
	  else {// Bonus shot
		Ten.Shot[2].removeActionListener(this);
                Ten.Shot[2].setEnabled(false);
		Ten.Shot[2].setEditable(false);
		if (Ten.Shot[2].getText().equals("10"))
			Ten.Shot[2].setText("X");
		shotBeingRead=0;
	  }
	  // Score the 10th frame
	  if (shotBeingRead==0) {
 	   if (nextFrameToScore==frameNum-2){
			total+=20+Ten.getShot(1);
			frame[frameNum-2].RunningTotal.setText("   "+String.valueOf(total));
			nextFrameToScore++;
	   }
	   if (nextFrameToScore==frameNum-1) {
		   if (frame[frameNum-1].isStrike())
				total+=10+Ten.getShot(1)+Ten.getShot(2);
		   else if (frame[frameNum-1].isSpare())
				total+=10+Ten.getShot(1);
		   frame[frameNum-1].RunningTotal.setText("   "+String.valueOf(total));
  		   nextFrameToScore++;
	   }
	   total+=Ten.getPins();
	   Ten.RunningTotal.setText("   "+String.valueOf(total));
	   Again.setVisible(true);
	   Quit.setVisible(true);
	  }
  }		// 10th frame else if
  else if (event.getActionCommand()=="Again?") {
	  BowlingFrame b=new BowlingFrame();
	  setVisible(false);
  }
  else if (event.getActionCommand()=="Quit?")
	  System.exit(0);

 } // ActionPerformed


 // Return bonus given game info
 static int computeBonus(BowlFramePanel[] Game,int frameNum)
 {if (Game[frameNum].isStrike())
	if (frameNum<9) {
		if (Game[frameNum+1].isStrike())
			return(10+Game[frameNum+2].getShot(1));
		return(Game[frameNum+1].getPins());
	}
	else
		return(Game[10].getShot(1)+Game[10].getShot(2));
		// Why not just call getPins()????
  if (Game[frameNum].isSpare())
	return(Game[frameNum+1].getShot(1));
  return(0);
 }

  public void windowClosed(WindowEvent event) {}
  public void windowDeiconified(WindowEvent event) {}
  public void windowIconified(WindowEvent event) {}
  public void windowActivated(WindowEvent event) {}
  public void windowDeactivated(WindowEvent event) {}
  public void windowOpened(WindowEvent event) {}
  public void windowClosing(WindowEvent event) { System.exit(0);}


} // End of class


public class Bowling
{

 public static void main(String[] args)
 {BowlingFrame b=new BowlingFrame();}


} //class
